function [ err, outParam, outLabels ] = BFMRFOpt(psi_alpha, h, w, pixPst, pixClr, useSpec)

    persistent MRFMessages;
    persistent IteCount;
    persistent labels;
    persistent param;
    
    for i=1:5

        if isempty(IteCount)
            IteCount = 0;
        end

        if isempty(labels)
            labels = kmeans(pixClr, 2);
        end

        if isempty(param)
            param = [InitParam(); InitParam()];
        end

        idx1 = find(labels==1);
        idx2 = find(labels==2);

        phi = zeros(h, w, 2);

        psi = [exp(psi_alpha), 1; 1, exp(psi_alpha)];
        psi = psi/sqrt(sum(psi(1, :).^2));

        pixClr1 = pixClr(idx1,:);
        pixPst1 = pixPst(idx1,:);
        pixClr2 = pixClr(idx2,:);
        pixPst2 = pixPst(idx2,:);
        param(1, :) = fsolve(@(param)BlinnPhongOpt(param, pixClr1, pixPst1, useSpec), param(1, :));
        param(2, :) = fsolve(@(param)BlinnPhongOpt(param, pixClr2, pixPst2, useSpec), param(2, :));

        clr1 = BlinnPhongPredict(param(1, :), pixClr, pixPst, useSpec);
        clr2 = BlinnPhongPredict(param(2, :), pixClr, pixPst, useSpec);

        err1 = min(clr1, 255) - pixClr;
        err2 = min(clr2, 255) - pixClr;

        err1 = err1/256;
        err2 = err2/256;

        err1 = sum(err1.^2, 2);
        err2 = sum(err2.^2, 2);

        phi(:, :, 1) = reshape(exp(-err1), [h,w]);
        phi(:, :, 2) = reshape(exp(-err2), [h,w]);

        if isempty(MRFMessages)
            [labels, ppb, MRFMessages] = MRFBP(phi, psi, 0.00001);
        else
            [labels, ppb, MRFMessages] = MRFBP(phi, psi, 0.00001, MRFMessages);
        end
        %labels = ones(h, w);
        %labels(find(err1>err2)) = 2;

        idx1 = find(labels==1);
        idx2 = find(labels==2);

        IteCount = IteCount+1;

        %if mod(IteCount,10)==0

            predImg = zeros(h, w, 3);
            predImg([idx1, idx1+w*h, idx1+w*h*2]) = min(clr1(idx1, :), 255);
            predImg([idx2, idx2+w*h, idx2+w*h*2]) = min(clr2(idx2, :), 255);

            figure(1);
            imshow(labels-1);
            figure(2);
            imshow(predImg/255);

        %end

        err = reshape(max(ppb, [], 3), [w*h,1]);
        err = err.*(exp(-err1)+exp(-err2));
        err = log(-err).^0.5;
    %    err = min(err1, err2).^0.5;

        outParam = param;
        outLabels = labels;
    end