function [predImg] = BPShadow(pstL, malpha, Cd, Cs, Ca, labels, shadowLabels, pstList, refImg)

    GlobalSetting;

    [h, w, clr] = size(refImg);
    wdiff = LightWeightDiff(pstList, pstL);
    wspec1 = LightWeightSpec(pstList(labels==1 & shadowLabels==0, :), pstL, malpha(1));
    wspec2 = LightWeightSpec(pstList(labels==2 & shadowLabels==0, :), pstL, malpha(2));
    predImg = zeros(h*w, 3);
    
    predImg(labels==1 & shadowLabels==0, :) = wdiff(labels==1 & shadowLabels==0)*Cd(1, :)+wspec1*Cs(1, :);
    predImg(labels==2 & shadowLabels==0, :) = wdiff(labels==2 & shadowLabels==0)*Cd(2, :)+wspec2*Cs(2, :);

    predImg(labels==1, :) = bsxfun(@plus, predImg(labels==1, :), Ca(1, :));
    predImg(labels==2, :) = bsxfun(@plus, predImg(labels==2, :), Ca(2, :));
    
    predImg = reshape(predImg, [h, w, 3]);
