    function [ col ] = BlinnPhong( alpha, thetaL, phiL, pstL, thetaN, phiN, pst, Cs, Cd, Ca, useSpec, isShadow)

    GlobalSetting;
    
    L = [sin(thetaL)*sin(phiL), sin(thetaL)*cos(phiL), cos(phiL)];
    N = [sin(thetaN)*sin(phiN), sin(thetaN)*cos(phiN), cos(phiN)];
    V = -bsxfun(@rdivide, pst, normVec(pst));
    LpV = bsxfun(@plus, V, L);
    
    % point light source assumption
    downpart = ((pstL(1)-pst(:,1)).^2+(pstL(2)-pst(:,2)).^2+pstL(3)^2).^0.5;
    if (isShadow==0)
        col = ones(size(pst,1),1)*pstL(3)./downpart.^3;
        col = col*Cd;
        %col = bsxfun(@plus, col, Ca(1)*Cd);
        if (useShadow == 1)
            col = bsxfun(@plus, col, Ca);
        end

        if (nargin>10 && useSpec==1)
            col = col+(ones(size(pst,1),1)*pstL(3)./downpart).^alpha./downpart.^2*Cs;
        end

        % parallel light source assumption
        %col = ones(size(pst,1), 1)*abs(L*N')*Cd;
        %col = bsxfun(@plus, (abs(LpV*N')./normVec(LpV)).^alpha*Cs, abs(L*N')*Cd);
        %col = ones(size(pst,1), 1)*Cd;
    else
        %col = ones(size(pst,1),1)*Ca(1)*Cd;
        col = ones(size(pst,1),1)*Ca;
    end