function [dparamr, dparamg, dparamb] = BlinnPhongDer(param, pst,  useSpec)

    DecodeParamCmd;
    
    downpart = ((pstL(1)-pst(:,1)).^2+(pstL(2)-pst(:,2)).^2+pstL(3)^2).^0.5;
    
    dpstLr = -3/2*pstL(3)*Cd(1)./downpart.^5*2*bsxfun(@minus, pstL, pst);
    dpstLg = -3/2*pstL(3)*Cd(2)./downpart.^5*2*bsxfun(@minus, pstL, pst);
    dpstLb = -3/2*pstL(3)*Cd(3)./downpart.^5*2*bsxfun(@minus, pstL, pst);
    
    dpstLr(3) = dpstLr(3)+Cd(1)./downpart.^3;
    dpstLg(3) = dpstLg(3)+Cd(2)./downpart.^3;
    dpstLb(3) = dpstLb(3)+Cd(3)./downpart.^3;
    
    dCdr = zeros(1, 3);
    dCdg = zeros(1, 3);
    dCdb = zeros(1, 3);
    
    dCdr(1) = pstL(3)./downpart.^3;
    dCdg(2) = pstL(3)./downpart.^3;
    dCdb(3) = pstL(3)./downpart.^3;
    
    dparamr = EncodeParam(0, 0, 0, dpstLr, 0, 0, 0, zeros(1, 3), dCdr, zeros(1, 3), 0);
    dparamg = EncodeParam(0, 0, 0, dpstLg, 0, 0, 0, zeros(1, 3), dCdg, zeros(1, 3), 0);
    dparamb = EncodeParam(0, 0, 0, dpstLb, 0, 0, 0, zeros(1, 3), dCdb, zeros(1, 3), 0);
    
    