function [output] = BlinnPhongGaussNField(alpha, pstL, pst, Cs, Cd, Ca, pixN, pixClr, gaussGamma, useSpec, isPredict)

    N = [sin(pixN(:, 1)).*sin(pixN(:, 2)), sin(pixN(:, 1)).*cos(pixN(:, 2)), cos(pixN(:, 2))]; 
    drtL = bsxfun(@minus, pstL, pst);
    drtL = bsxfun(@rdivide, drtL, normVec(drtL));
    H = bsxfun(@plus, drtL, [0,0,1]);
    H = bsxfun(@rdivide, H, normVec(H));

    col = dot(N', drtL')*Cd;
    if useSpec==1
        col = col+dot(H',  N').^alpha*Cs;
    end
    
    if isPredict==1
        output=col
    else
        output=min(col, 255)-pixClr;
        output=-output.^2;
        logppb=-gaussGamma+gaussGamma*N(:,3);
        logppb=logppb+log(2*pi/gaussGamma*(1-exp(2*gaussGamma)));
        output=output+logppb;
    end
end