function [ Cd, Cs ] = CalcBlurDiff(pstList, clrList, img, labels, kernel, pstL, malpha)

    GlobalSetting;

    [h, w, clr] = size(img);

    %labelslist1 = find(labels==1);
    %labelslist2 = find(labels==2);
    
    lightDiffImg1 = zeros(h*w, 1);
    lightDiffImg2 = zeros(h*w, 1);
    
    lightDiffImg1(labels==1) = LightWeightDiff(pstList(labels==1, :), pstL);
    lightDiffImg2(labels==2) = LightWeightDiff(pstList(labels==2, :), pstL);

    lightSpecImg1 = zeros(h*w, 1);
    lightSpecImg2 = zeros(h*w, 1);
    
    if useSpec==1
        lightSpecImg1(labels==1) = LightWeightSpec(pstList(labels==1, :), pstL, malpha(1));
        lightSpecImg2(labels==2) = LightWeightSpec(pstList(labels==2, :), pstL, malpha(2));
    end    

    lightDiffImg1 = reshape(lightDiffImg1, [h, w]);
    lightDiffImg2 = reshape(lightDiffImg2, [h, w]);
    
    lightSpecImg1 = reshape(lightSpecImg1, [h, w]);
    lightSpecImg2 = reshape(lightSpecImg2, [h, w]);
    
    diffconv1 = imfilter(lightDiffImg1, kernel, 'replicate');
    diffconv2 = imfilter(lightDiffImg2, kernel, 'replicate');
    
    diffconv1 = reshape(diffconv1, [h*w, 1]);
    diffconv2 = reshape(diffconv2, [h*w, 1]);
    
    specconv1 = imfilter(lightSpecImg1, kernel, 'replicate');
    specconv2 = imfilter(lightSpecImg2, kernel, 'replicate');
    
    specconv1 = reshape(specconv1, [h*w, 1]);
    specconv2 = reshape(specconv2, [h*w, 1]);
    
    halfA = [diffconv1, diffconv2, specconv1, specconv2];
    
    B = halfA'*clrList;
    
    A = halfA'*halfA;
    
    %d11 = sum(diffconv1.^2);
    %d12 = diffconv1'*diffconv2;
    %d22 = sum(diffconv2.^2);
    
    %A = [d11, d12; d12, d22];
    %B = [diffconv1'*clrList;diffconv2'*clrList];
    
    Call = zeros(4, 3);

    %try
        invA = pinv(A);
        invA = real(invA);
%        if ~all(isreal(invA))
%            invA
%        end
        
    %catch exp
    %    exp
    %end
    for chan=1:3
        Call(:, chan) = invA*B(:, chan);%linsolve(A, B(:, chan));
    end

    Cd = Call(1:2, :);
    Cs = Call(3:4, :);