function [ Cd, Cs, Ca ] = CalcBlurShadow(pstList, clrList, img, labels, shadowLabels, kernel, pstL, malpha)

    GlobalSetting;

    [h, w, clr] = size(img);

    %labelslist1 = find(labels==1);
    %labelslist2 = find(labels==2);
    
    lightDiffImg1 = zeros(h*w, 1);
    lightDiffImg2 = zeros(h*w, 1);
    
    lightDiffImg1(labels==1 | shadowLabels==0) = LightWeightDiff(pstList(labels==1 | shadowLabels==0, :), pstL);
    lightDiffImg2(labels==2 | shadowLabels==0) = LightWeightDiff(pstList(labels==2 | shadowLabels==0, :), pstL);

    lightSpecImg1 = zeros(h*w, 1);
    lightSpecImg2 = zeros(h*w, 1);
    
    if useSpec==1
        lightSpecImg1(labels==1 | shadowLabels==0) = LightWeightSpec(pstList(labels==1 | shadowLabels==0, :), pstL, malpha(1));
        lightSpecImg2(labels==2 | shadowLabels==0) = LightWeightSpec(pstList(labels==2 | shadowLabels==0, :), pstL, malpha(2));
    end    
    
    lightAmbientImg1 = zeros(h*w, 1);
    lightAmbientImg2 = zeros(h*w, 1);
    
    lightAmbientImg1(labels==1) = 1;
    lightAmbientImg2(labels==2) = 1;

    lightDiffImg1 = reshape(lightDiffImg1, [h, w]);
    lightDiffImg2 = reshape(lightDiffImg2, [h, w]);
    
    lightSpecImg1 = reshape(lightSpecImg1, [h, w]);
    lightSpecImg2 = reshape(lightSpecImg2, [h, w]);
    
    lightAmbientImg1 = reshape(lightAmbientImg1, [h, w]);
    lightAmbientImg2 = reshape(lightAmbientImg2, [h, w]);
    
    diffconv1 = imfilter(lightDiffImg1, kernel, 'replicate');
    diffconv2 = imfilter(lightDiffImg2, kernel, 'replicate');
    
    diffconv1 = reshape(diffconv1, [h*w, 1]);
    diffconv2 = reshape(diffconv2, [h*w, 1]);
    
    specconv1 = imfilter(lightSpecImg1, kernel, 'replicate');
    specconv2 = imfilter(lightSpecImg2, kernel, 'replicate');
    
    specconv1 = reshape(specconv1, [h*w, 1]);
    specconv2 = reshape(specconv2, [h*w, 1]);
    
    ambientv1 = imfilter(lightAmbientImg1, kernel, 'replicate');
    ambientv2 = imfilter(lightAmbientImg2, kernel, 'replicate');
    
    ambientv1 = reshape(ambientv1, [h*w, 1]);
    ambientv2 = reshape(ambientv2, [h*w, 1]);
    
    halfA = [diffconv1, diffconv2, specconv1, specconv2, ambientv1, ambientv2];
    
    B = halfA'*clrList;
    
    A = halfA'*halfA;
    
    Call = zeros(6, 3);

    invA = pinv(A);
    invA = real(invA);

    for chan=1:3
        Call(:, chan) = invA*B(:, chan);%linsolve(A, B(:, chan));
    end

    Cd = Call(1:2, :);
    Cs = Call(3:4, :);
    Ca = Call(5:6, :);