function [ crossPts ] = CheckerDetect( binImg )

    binImg = double(binImg);
    checkerSize = 4;
    thresHold = 5;
    checkerOriginal = checkerboard(checkerSize, 1, 1);
    binChecker = (checkerOriginal>0.5)-0.5;
    
    filteredImg = imfilter(binImg, binChecker);
    maxpeak = filteredImg > imdilate(filteredImg, [1 1 1; 1 0 1; 1 1 1]);
    minpeak = filteredImg < imerode(filteredImg, [1 1 1; 1 0 1; 1 1 1]);
    peakImg = maxpeak | minpeak;
    
    crossPts = find(peakImg & (abs(filteredImg)>thresHold));
    imshow(peakImg & (abs(filteredImg)>thresHold));
    