function [labels, recon, err] = DeblurEmbed(recon1, recon2, img, kernel)

    GlobalSetting;

    %deblurImg = deconvlucy(img, kernel);
    if size(kernel,1)==1 || useErodeDeblur==1
        deblurImg = img;
    else
        [deblurImg, kernel] = deconvblind(img, kernel);
    end
    [h, w, clr] = size(recon1);
    labels = ones(h, w);
    recon1 = min(recon1, 255);
    recon2 = min(recon2, 255);
    idx = sum((recon1-deblurImg).^2, 3)>sum((recon2-deblurImg).^2, 3);
    labels(idx) = 2;
    
    if useErodeDeblur==1
        [labels, reconDeblur, recon, err] = ResultDeblur_erode(labels, recon1, recon2, img, kernel);
    else
        findIdx = find(idx);
        recon = recon1;
        recon(findIdx) = recon2(findIdx);
        recon(findIdx+w*h) = recon2(findIdx+w*h);
        recon(findIdx+2*w*h) = recon2(findIdx+2*w*h);
        recon = imfilter(recon, kernel, 'replicate');
        err = sum(sum(sum((recon-img).^2))).^0.5;
    end