function [labels, shadowLabels, recon, err] = DeblurEmbedShadow(recon1, recon1Shadow, recon2, recon2Shadow, img, kernel)

    %deblurImg = deconvlucy(img, kernel);
    if size(kernel,1)==1
        deblurImg = img;
    else
        [deblurImg] = deconvlucy(img, kernel);
    end
    [h, w, clr] = size(recon1);
    labels = ones(h, w);
    shadowLabels = zeros(h, w);
    
    recon1 = min(recon1, 255);
    recon2 = min(recon2, 255);
    recon1Shadow = min(recon1Shadow, 255);
    recon2Shadow = min(recon2Shadow, 255);
    
    val = zeros(h, w, 4);
    val(:,:,1) = sum((recon1-deblurImg).^2, 3);
    val(:,:,2) = sum((recon1Shadow-deblurImg).^2, 3);
    val(:,:,3) = sum((recon2-deblurImg).^2, 3);
    val(:,:,4) = sum((recon2Shadow-deblurImg).^2, 3);
    
    [minval, labelIdx] = min(val, [], 3);
    labels(labelIdx==1 | labelIdx==2) = 1;
    labels(labelIdx==3 | labelIdx==4) = 2;
    shadowLabels(labelIdx==1 | labelIdx==3) = 0;
    shadowLabels(labelIdx==2 | labelIdx==4) = 1;

    recon = zeros(h*w, 3);
    recon1t = reshape(recon1, [h*w, 3]);
    recon1st = reshape(recon1Shadow, [h*w, 3]);
    recon2t = reshape(recon2, [h*w, 3]);
    recon2st = reshape(recon2Shadow, [h*w, 3]);

    recon(labelIdx==1, :) = recon1t(labelIdx==1, :);
    recon(labelIdx==2, :) = recon1st(labelIdx==2, :);
    recon(labelIdx==3, :) = recon2t(labelIdx==3, :);
    recon(labelIdx==4, :) = recon2st(labelIdx==4, :);
    
    recon = reshape(recon, [h,w,3]);
    recon = imfilter(recon, kernel, 'replicate');
    err = sum(sum(sum((recon-img).^2))).^0.5;
    