function [labels, ppb, messages] = MRFBP(phi, psi, epsilon, messages)

        [h, w, numLabels] = size(phi);
        if nargin==3
            messages = ones([h, w, numLabels, 4]);
        end

        drt = [1, 0; 0, 1; -1, 0; 0, -1];

        while true
            oldMessages = messages;
            for d = 1:4
                messageUpdate = ones([h, w, numLabels]);
                for dd=1:4
                    if abs(d-dd)~=2
                        begIdx = max([1,1], [1,1]+drt(d,:)+drt(dd,:))-drt(d,:)-drt(dd,:);
                        endIdx = min([h,w], [h,w]+drt(d,:)+drt(dd,:))-drt(d,:)-drt(dd,:);
                        idxv = begIdx(1):endIdx(1);
                        idxh = begIdx(2):endIdx(2);
                        messageUpdate(idxv, idxh, :) = messageUpdate(idxv, idxh, :).*messages(idxv+drt(d,1), idxh+drt(d,2), :, dd);
                    end
                end
                for xj=1:numLabels
                    messages(:,:,xj,d)=0;
                    begIdx = max([1,1], [1,1]+drt(d,:))-drt(d,:);
                    endIdx = min([h,w], [h,w]+drt(d,:))-drt(d,:);
                    idxv = begIdx(1):endIdx(1);
                    idxh = begIdx(2):endIdx(2);
                    for xi=1:numLabels
                        messages(idxv,idxh,xj,d)=messages(idxv,idxh,xj,d)+messageUpdate(idxv,idxh,xi).*psi(xi,xj).*phi(idxv+drt(d,1),idxh+drt(d,2),xi);
                    end
                end
            end
            summess = sum(messages, 3);
            messages = bsxfun(@rdivide, messages, summess);
            messages(isnan(messages))=0;
            err = max(max(max(max(abs(oldMessages-messages)))));
            if err<epsilon
                break;
            end
        end

        ppb = phi;
        for d=1:4
            begIdx = max([1,1], [1,1]+drt(d,:))-drt(d,:);
            endIdx = min([h,w], [h,w]+drt(d,:))-drt(d,:);
            idxv = begIdx(1):endIdx(1);
            idxh = begIdx(2):endIdx(2);
            ppb(idxv, idxh, :) = ppb(idxv, idxh, :) .* messages(idxv, idxh, :, d);
        end
        ppb = bsxfun(@rdivide, ppb, sum(ppb, 3));

        [val, labels] = max(ppb, [], 3);
