function [labels, bf1param, bf2param, recon] = NumBPhongOpt(img, iteNum, inIdx, in1param, in2param)

    useSpec = 0;
    GlobalSetting;
    
    useShadow = 0;

    [h, w, clr]= size(img);

    sizeScale = (w^2+h^2)^0.5;
    idx = 1:(w*h);
    idx = idx';
    [x, y] = ind2sub([h, w], idx);
    pixPst = [x,y]/sizeScale;
    pixClr = [img(idx), img(idx+w*h), img(idx+w*h*2)];

    labels=zeros(h,w);
        
    if (nargin>4)
        
        bf1param = in1param;
        bf2param = in2param;
        
        idx1 = find(inIdx==1);
        idx2 = find(inIdx==2);        
        
        if useShadow==1 && shadowInit==1
            pixClr1 = pixClr(idx1,:);
            pixPst1 = pixPst(idx1,:);
            pixClr2 = pixClr(idx2,:);
            pixPst2 = pixPst(idx2,:);
            
            bf1param = InitAmbient(bf1param, pixClr1, pixPst1, useSpec);
            bf2param = InitAmbient(bf2param, pixClr2, pixPst2, useSpec);
            
        end

    else

        bf1param = EncodeParam(rand()*10, rand()*pi, rand()*2*pi, rand(1,3), rand()*pi, rand()*2*pi, rand()*100, rand(1,3)*255, rand(1,3)*255, rand(1,3)*1, rand(1,1));
        %bf2param = EncodeParam(rand()*10, rand()*pi, rand()*2*pi, rand()*pi, rand()*2*pi, rand()*100, rand(1,3)*255, rand(1,3)*255);
        bf2param = bf1param;

        clusteridx = kmeans(pixClr, 2);

        idx1 = find(clusteridx==1);
        idx2 = find(clusteridx==2);
        
    end
%    idx2 = idx1(floor(h*w/2)+1:h*w);
%    idx1 = idx1(1:floor(h*w/2));
    
    pixClr1 = pixClr(idx1,:);
    pixPst1 = pixPst(idx1,:);
    pixClr2 = pixClr(idx2,:);
    pixPst2 = pixPst(idx2,:);
    
    predImg = zeros(h, w, 3);
    
    %for useSpec=0:0
        for t=1:iteNum
            opt = 1;
            bf1param = fsolve(@(param)BlinnPhongOpt(param, pixClr1, pixPst1, useSpec), bf1param);
            bf2param = fsolve(@(param)BlinnPhongOpt(param, pixClr2, pixPst2, useSpec), bf2param);
            bf1param(1, 13:15) = CalcDiff(pixPst1, pixClr1, bf1param(1, 4:6));
            bf2param(1, 13:15) = CalcDiff(pixPst2, pixClr2, bf2param(1, 4:6));
            opt = 0;
            rank1 = normVec(BlinnPhongOpt(bf1param, pixClr, pixPst, useSpec));
            rank2 = normVec(BlinnPhongOpt(bf2param, pixClr, pixPst, useSpec));
            rank1 = rank1(1:size(rank1,1)-1);
            rank2 = rank2(1:size(rank2,1)-1);
            idx1 = find(rank1<=rank2);
            idx2 = find(rank1>rank2);
            pixClr1 = pixClr(idx1,:);
            pixPst1 = pixPst(idx1,:);
            pixClr2 = pixClr(idx2,:);
            pixPst2 = pixPst(idx2,:);
            labels(idx1) = 1;
            labels(idx2) = 2;
            figure(1);
            imshow(labels-1);  

            predClr1 = BlinnPhongPredict(bf1param, pixClr1, pixPst1, useSpec);
            predClr2 = BlinnPhongPredict(bf2param, pixClr2, pixPst2, useSpec);

            predImg([idx1, idx1+w*h, idx1+w*h*2]) = predClr1;
            predImg([idx2, idx2+w*h, idx2+w*h*2]) = predClr2;

            figure(2);
            imshow(predImg/255);

            drawnow
            recon = predImg/255;
        end
    end