function [R,A,nbasis] = RadialMeanPlane(img)

nbasis = min(size(img))/2;

R = zeros(1, nbasis);
A = zeros(1, nbasis);

nelem = zeros(nbasis, 1);

size2 = size(img);
mid = size2/2 + 1;
p = zeros(nbasis,nbasis*nbasis);


for i = 1:size2(1)
    for j = 1:size2(2)
       freq = floor(sqrt(((i-mid(1))/size2(1)*nbasis*2)^2+((j-mid(2))/size2(2)*nbasis*2)^2))+1;
       if (freq > nbasis) continue; end
       nelem(freq,1) = nelem(freq,1) + 1;
       p(freq, nelem(freq,1)) = img(i,j);
    end
end

for i = 1:nbasis
	if (nelem(i,1) == 0)
		R(1,i) = 0;
		A(1,i) = 0;
	else
	    R(1,i) = mean(p(i,1:nelem(i,1)));
    	A(1,i) = var(p(i,1:nelem(i,1))) / R(1,i)^2;
	end
end
