function [ img, diff1, diff2, spec1, spec2 ] = ReconImg( idx, bf1param, bf2param )

    [height, width] = size(idx);
    wh = width*height;

    img = zeros( height, width, 3);
    diff2 = zeros(height, width, 3);

    diff2(:, :, 3) = 255;
    diff1 = diff2;
    spec1 = diff2;
    spec2 = diff2;

    idx1 = find(idx==1);
    idx2 = find(idx==2);
    
    pstIdx = 1:(wh);
    pstIdx = pstIdx';
    [x, y] = ind2sub([height, width], pstIdx);
    pixPst = [x,y];
    
    diff1([idx1, idx1+wh, idx1+2*wh]) = BFDiffuse(pixPst(idx1, :), bf1param);
    diff2([idx2, idx2+wh, idx2+2*wh]) = BFDiffuse(pixPst(idx2, :), bf2param);
    
    spec1([idx1, idx1+wh, idx1+2*wh]) = BFSpecular(pixPst(idx1, :), bf1param);
    spec2([idx2, idx2+wh, idx2+2*wh]) = BFSpecular(pixPst(idx2, :), bf2param);
    
    figure(1);
    imshow(diff1);
    figure(2);
    imshow(diff2);
    
    figure(3);
    imshow(spec1);
    figure(4);
    imshow(spec2);
    
    img([idx1, idx1+wh, idx1+2*wh]) = diff1([idx1, idx1+wh, idx1+2*wh])+spec1([idx1, idx1+wh, idx1+2*wh]);
    img([idx2, idx2+wh, idx2+2*wh]) = diff2([idx2, idx2+wh, idx2+2*wh])+spec2([idx2, idx2+wh, idx2+2*wh]);
    
    figure(5);
    imshow(img);
end

